/*
 * Dozen Phi Applet
 * dozencanvas.java -- drawing class
 * (C) 1999 Visual Perception Lab, Purdue University
 * Author: Filip Pizlo
 */

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;

public class dozencanvas extends Canvas implements Runnable {
 public void logit(String msg) {
  System.out.println(getClass().getName()+": "+msg);
 }
 Applet base;
 Graphics vg;
 Image vbuf;
 public dozencanvas(Applet _base) {
  super();
  base=_base;
  doti=0;
  setparams(9,5,25,33);
 }
 int dots,size,radius;
 long delay;
 public synchronized void setparams(int _dots,int _size,int _radius,long _delay) {
  dots=_dots;
  size=_size;
  radius=_radius;
  delay=_delay;
  doti%=dots;
/*  logit("dots="+dots);
  logit("size="+size);
  logit("radius="+radius);
  logit("delay="+delay);*/
  dodrawing();
 }
 public void setdots(int _dots) { setparams(_dots,size,radius,delay); }
 public void setsize(int _size) { setparams(dots,_size,radius,delay); }
 public void setradius(int _radius) { setparams(dots,size,_radius,delay); }
 public void setdelay(long _delay) { setparams(dots,size,radius,_delay); }
 public int getdots() { return dots; }
 public int getsize() { return size; }
 public int getradius() { return radius; }
 public long getdelay() { return delay; }
 int doti;
 Thread dostuff;
 public void start() {
  if (!running) {
   dostuff=new Thread(this);
   cont=true;
   dostuff.start();
   if (dback!=null) dback.start();
  }
 }
 public synchronized void stop() {
  if (running) {
   cont=false;
   notifyAll();
   dostuff=null;
   if (dback!=null) dback.stop();
  }
 }
 boolean cont=false,running=false,cmode=false,multi=false;
 Color fg=Color.white,bg1=Color.black,bg2=Color.black;
 public synchronized void togglecolors() {
  cmode=!cmode;
  setcolors(cmode);
  dodrawing();
 }
 public synchronized void togglemulti() {
  multi=!multi;
  dodrawing();
 }
 public synchronized void setcolors(boolean _cmode) {
  if (_cmode) setcolors(Color.black,Color.white);
  else setcolors(Color.white,Color.black);
 }
 boolean beta;
 public synchronized void setbeta(boolean _beta) {
  beta=_beta;
  dodrawing();
 }
 public boolean getbeta() { return beta; }
 public synchronized void togglebeta() { setbeta(!getbeta()); }
 public synchronized void setcolors(Color _fg,Color _bg) {
  fg=_fg;
  bg1=_bg;
  bg2=_bg;
  redoPoly();
  dodrawing();
 }
 public synchronized void splitColors(Color _bg1,Color _bg2) {
  bg1=_bg1;
  bg2=_bg2;
  dodrawing();
 }
 public Color getfgcolor() { return fg; }
 public Color getbgcolor() { return bg1; }
 public synchronized void setmulti(boolean _multi) {
  multi=_multi;
  dodrawing();
 }
 graphlet dback=null;
 public synchronized void setGraphlet(graphlet _dback) {
  if (dback!=null) dback.stop();
  dback=_dback;
  if (dback!=null) dback.start();
  dodrawing();
 }
 double pi=3.14159,pi2=pi*2.0;
 public synchronized void dodrawing() {
  if (!imageok) return;
  double ang=0.0,dang=pi2/((double)dots);
  //logit("Angles: ang="+ang+" dang="+dang+" pi2="+pi2);
  if (realBgImg!=null) {
   vg.drawImage(realBgImg,0,0,this);
  } else if (dback==null) {
   vg.setColor(bg1);
   vg.fillRect(0,0,getSize().width/4,getSize().height);
   vg.fillRect((getSize().width*3)/4,0,getSize().width/4,getSize().height);
   vg.setColor(bg2);
   vg.fillRect(getSize().width/4,0,getSize().width/2,getSize().height);
  } else {
   dback.paint(vg);
  }
  vg.setColor(fg);
  int offsetx,offsety;
  if (multi) {
   offsetx=getSize().width/4;
   offsety=getSize().height/2;
  } else {
   offsetx=getSize().width/2;
   offsety=getSize().height/2;
  }
  int i=0;
  while (i<dots) {
   if ((i==doti)==beta) {
    double x=Math.cos(ang)*((double)radius);
    double y=Math.sin(ang)*((double)radius);
    //logit("Drawing: x="+x+" y="+y);
    int ix=((int)x)+offsetx;
    int iy=((int)y)+offsety;
    drawPhi(vg,ix,iy,size);
    if (multi) drawPhi(vg,getSize().width-ix,iy,size);
   }
   ang+=dang;
   i++;
  }
  super.repaint();
 }
 public void repaint() { dodrawing(); }
 public static final int
  FILL_OVAL=0,
  DRAW_OVAL=1,
  FILL_RECT=2,
  DRAW_RECT=3,
  DRAW_TEXT=4,
  FILL_POLY=6,
  DRAW_IMAGE=5;
 String text="PHI";
 Font textFont=new Font("Dialog",0,14);
 Image img,bgImg,realBgImg;
 Dimension imgD,bgImgD;
 int mode=FILL_OVAL;
 public synchronized void setDrawMode(int _mode) {
  mode=_mode;
  redoPoly();
  dodrawing();
 }
 int[] polyX,polyY;
 int polyN;
 public void redoPoly() {
  if (mode==FILL_POLY) {
   int[] x=new int[10];
   int[] y=new int[10];
   Random rand=new Random();
   for (int i=0;i<10;i++) {
    x[i]=Math.abs(rand.nextInt()%(size*2));
    y[i]=Math.abs(rand.nextInt()%(size*2));
   }
   polyX=x;
   polyY=y;
   polyN=10;
  }
 }
 public synchronized void setText(String _text,Font _textFont) {
  if (_text!=null) text=_text;
  if (_textFont!=null) textFont=_textFont;
  dodrawing();
 }
 public synchronized void setImage(Image _img,Dimension _imgD) {
  img=_img;
  imgD=_imgD;
  dodrawing();
 }
 public synchronized void setBgImage(Image _img,Dimension _imgD) {
  if (_img==null) realBgImg=null;
  else {
   bgImg=_img;
   bgImgD=_imgD;
   realBgImg=createImage(getSize().width,getSize().height);
   Graphics vg=realBgImg.getGraphics();
   for (int x=0;x<getSize().width+bgImgD.width;x+=bgImgD.width) {
    for (int y=0;y<getSize().height+bgImgD.height;y+=bgImgD.height) {
     vg.drawImage(bgImg,x,y,this);
    }
   }
  }
  dodrawing();
 }
 public void drawPhi(Graphics g,int x,int y,int size) {
  switch (mode) {
   case FILL_OVAL:
    g.fillOval(x-size,y-size,size*2,size*2);
    break;
   case DRAW_OVAL:
    g.drawOval(x-size,y-size,size*2,size*2);
    break;
   case FILL_RECT:
    g.fillRect(x-size,y-size,size*2,size*2);
    break;
   case DRAW_RECT:
    g.drawRect(x-size,y-size,size*2,size*2);
    break;
   case DRAW_TEXT:
    g.setFont(textFont);
    FontMetrics fm=getFontMetrics(textFont);
    g.drawString(text,x-(fm.stringWidth(text)/2),
     y-(fm.getHeight()/2)+fm.getAscent());
    break;
   case DRAW_IMAGE:
    g.drawImage(img,x-imgD.width,y-imgD.height,this);
    break;
   case FILL_POLY:
    g.translate(x-size,y-size);
    g.fillPolygon(polyX,polyY,polyN);
    g.translate(size-x,size-y);
    break;
   default:
    break;
  }
 }
 public synchronized void run() {
  try {
   running=true;
   initimage();
   while (cont) {
    dodrawing();
    try {
     wait(delay);
     doti++;
     if (doti>=dots) doti=0;
    } catch (InterruptedException e) {}
   }
  } catch (Throwable e) {
   logit("Error in thread: "+e);
  } finally {
   running=false;
  }
 }
 public void update(Graphics g) {
//  g.setColor(Color.black);
//  g.fillRect(0,0,getSize().width,getSize().height);
  paint(g);
 }
 boolean imageok=false;
 public void initimage() {
  if (imageok) return;
  logit("Creating vbuf");
  vbuf=base.createImage(getSize().width,getSize().height);
  logit("Image inited");
  vg=vbuf.getGraphics();
  logit("Graphics inited");
  imageok=true;
 }
 public void paint(Graphics g) {
  if (imageok) g.drawImage(vbuf,0,0,this);
  else g.fillRect(0,0,getSize().width,getSize().height);
 }
}



